" Digraphs
" https://en.wikipedia.org/wiki/Mathematical_operators_and_symbols_in_Unicode
" https://github.com/joom/latex-unicoder.vim/blob/master/autoload/unicoder.vim


"" Currency
digr Rs 8360  " ₨  
digr rs 8377  " ₹ (INR)


"" Set theory
digr )- 8713  " ∉
digr xx 10799  " ⨯ (cross product)


"" boolean algebra
digr +o 8853  " ⊕


"" Super-script characters
" Note: q, C, F, Q, S, X, Y, Z haven't got super-script version.
digr ^0 8304  " ⁰ (duplicate of 0S)
digr ^1 185   " ¹ (duplicate of 1S)
digr ^2 178   " ² (duplicate of 2S)
digr ^3 179   " ³ (duplicate of 3S)
digr ^4 8308  " ⁴ (duplicate of 4S)
digr ^5 8309  " ⁵ (duplicate of 5S)
digr ^6 8310  " ⁶ (duplicate of 6S)
digr ^7 8311  " ⁷ (duplicate of 7S)
digr ^8 8312  " ⁸ (duplicate of 8S)
digr ^9 8313  " ⁹ (duplicate of 9S)
digr ^a 7491  " ᵃ
digr ^b 7495  " ᵇ
digr ^c 7580  " ᶜ
digr ^d 7496  " ᵈ
digr ^e 7497  " ᵉ
digr ^f 7584  " ᶠ
digr ^g 7501  " ᵍ
digr ^h  688  " ʰ
digr ^i 8305  " ⁱ
digr ^j  690  " ʲ
digr ^k 7503  " ᵏ
digr ^l  737  " ˡ
digr ^m 7504  " ᵐ
digr ^n 8319  " ⁿ
digr ^o 7506  " ᵒ
digr ^p 7510  " ᵖ
digr ^r  691  " ʳ
digr ^s  738  " ˢ
digr ^t 7511  " ᵗ
digr ^u 7512  " ᵘ
digr ^v 7515  " ᵛ
digr ^w  695  " ʷ
digr ^x  739  " ˣ
digr ^y  696  " ʸ
digr ^z 7611  " ᶻ
digr ^A 7468  " ᴬ
digr ^B 7470  " ᴮ
digr ^D 7472  " ᴰ
digr ^E 7473  " ᴱ
digr ^G 7475  " ᴳ
digr ^H 7476  " ᴴ
digr ^I 7477  " ᴵ
digr ^J 7478  " ᴶ
digr ^K 7479  " ᴷ
digr ^L 7480  " ᴸ
digr ^M 7481  " ᴹ
digr ^N 7482  " ᴺ
digr ^O 7484  " ᴼ
digr ^P 7486  " ᴾ
digr ^R 7487  " ᴿ
digr ^T 7488  " ᵀ
digr ^U 7489  " ᵁ
digr ^V 11389  " ⱽ
digr ^W 7490  " ᵂ

digr ^+ 8314  " ⁺ (duplicate of +S)
digr ^- 8315  " ⁻ (duplicate of -S)
digr ^= 8316  " ⁼
digr ^( 8317  " ⁽
digr ^) 8318  " ⁾

digr [[ 10214  " ⟦
digr ]] 10215  " ⟧


"" Sub-script characters
" Note: b, c, d, f, g, q, w, y, z haven't got sub-script version.
" Note: No upper case Latin letter has got sub-script version.
digr _0 8320  " ₀ (duplicate of 0s)
digr _1 8321  " ₁ (duplicate of 1s)
digr _2 8322  " ₂ (duplicate of 2s)
digr _3 8323  " ₃ (duplicate of 3s)
digr _4 8324  " ₄ (duplicate of 4s)
digr _5 8325  " ₅ (duplicate of 5s)
digr _6 8326  " ₆ (duplicate of 6s)
digr _7 8327  " ₇ (duplicate of 7s)
digr _8 8328  " ₈ (duplicate of 8s)
digr _9 8329  " ₉ (duplicate of 9s)
digr _a 8336  " ₐ
digr _e 8337  " ₑ
digr _h 8341  " ₕ
digr _i 7522  " ᵢ
digr _j 11388  " ⱼ
digr _k 8342  " ₖ
digr _l 8343  " ₗ
digr _m 8344  " ₘ
digr _n 8345  " ₙ
digr _o 8338  " ₒ
digr _p 8346  " ₚ
digr _r 7523  " ᵣ
digr _s 8347  " ₛ
digr _t 8348  " ₜ
digr _u 7524  " ᵤ
digr _v 7525  " ᵥ
digr _x 8339  " ₓ

digr _+ 8330  " ₊ (duplicate of +s)
digr _- 8331  " ₋ (duplicate of -s)
digr _= 8332  " ₌
digr _( 8333  " ₍
digr _) 8334  " ₎


"" Italic letters (resemble italics syntax in emacs org-mode)
digr /A 119860  " 𝐴
digr /B 119861  " 𝐵
digr /C 119862  " 𝐶
digr /D 119863  " 𝐷
digr /E 119864  " 𝐸
digr /F 119865  " 𝐹
digr /G 119866  " 𝐺
digr /H 119867  " 𝐻
digr /I 119868  " 𝐼
digr /J 119869  " 𝐽
digr /K 119870  " 𝐾
digr /L 119871  " 𝐿
digr /M 119872  " 𝑀
digr /N 119873  " 𝑁
digr /O 119874  " 𝑂
digr /P 119875  " 𝑃
digr /Q 119876  " 𝑄
digr /R 119877  " 𝑅
digr /S 119878  " 𝑆
digr /T 119879  " 𝑇
digr /U 119880  " 𝑈
digr /V 119881  " 𝑉
digr /W 119882  " 𝑊
digr /X 119883  " 𝑋
digr /Y 119884  " 𝑌
digr /Z 119885  " 𝑍
digr /a 119886  " 𝑎
digr /b 119887  " 𝑏
digr /c 119888  " 𝑐
digr /d 119889  " 𝑑
digr /e 119890  " 𝑒
digr /f 119891  " 𝑓 (overriding ⁄: Fraction slash)
digr /g 119892  " 𝑔
digr /h 8462  " ℎ (using Planck constant)
digr /i 119894  " 𝑖
digr /j 119895  " 𝑗
digr /k 119896  " 𝑘
digr /l 119897  " 𝑙
digr /m 119898  " 𝑚
digr /n 119899  " 𝑛
digr /o 119900  " 𝑜
digr /p 119901  " 𝑝
digr /q 119902  " 𝑞
digr /r 119903  " 𝑟
digr /s 119904  " 𝑠
digr /t 119905  " 𝑡
digr /u 119906  " 𝑢
digr /v 119907  " 𝑣
digr /w 119908  " 𝑤
digr /x 119909  " 𝑥
digr /y 119910  " 𝑦
digr /z 119911  " 𝑧


"" Number sets
digr NN 8469  " ℕ: Set of natural numbers
digr RR 8477  " ℝ: Set of real numbers
digr ZZ 8484  " ℤ: Set of integers
digr CC 8450  " ℂ: Set of complex numbers (overriding ~T: Cancel character)
digr QQ 8474  " ℚ: Set of rational numbers
digr BB 120121  " 𝔹: Set of Booleans (overriding ¦)


"" Constants
digr ee 8495  " ℯ: Euler's number ≅ 2.71828
digr ph 8501  " ℵ : Aleph number (in addition to א (A+))


"" Fancy stuff
digr el 8467  " ℓ
digr dt 8901  " ⋅ ('small dot')
digr DT 8226  " • ('big dot') (overriding ^?: DELETE character)


"" Proof theory stuff
digr TN 8708  " ∄ (Since ∃ is TE)
digr n< 8602  " ↚ (Since ← is <-)
digr n> 8603  " ↛ (Since → is ->)
digr -^ 8593  " ↑ (Since ↓ is -v)
digr pr 8866  " ⊢
digr MO 8872  " ⊨
digr np 8876  " ⊬
digr NM 8877  " ⊭
digr bx 9633  " □ (duplicate of OS)
digr dm 9671  " ◇ (duplicate of Dw)
digr !3 8802  " ≢ (because ≡ is `digr =3`)
digr mp 8614  " ↦: maps to
"digr FF 10200 " ⟘ (like False) (overriding : Form feed)
"digr TT 10201 " ⟙ (like True) (duplicate of -T)
digr FF 8869  " ⊥ (like False) (overriding : Form feed)
digr TT 8868  " ⊤ (like True) (duplicate of -T)


"" Basic math stuff
""" Roots of numbers
digr r2 8730  " √ (square root) (duplicate of RT)
digr r3 8731  " ∛ (cube root)
digr r4 8732  " ∜ (fourth root)

""" Lines
digr pp 10178  " ⟂ (perpendicular to)
digr ll 8214  " ‖ (parallel to)

""" Integration
digr Im 9134  " ⎮ (Since ⌠ is Iu and ⌡ is Il)


"" Quantum theory stuff
digr kt 10217  " ⟩ (ket symbol)


" 'Modifier'-like
digr ~~ 822  " strikethrough text overlay


"" With grave
" digr a`        " à


"" With tilde
digr A~ 195  " Ã (duplicate of 'A?')
digr E~ 7868 " Ẽ (duplicate of 'E?')
digr I~ 296  " Ĩ (duplicate of 'I?')
digr N~ 209  " Ñ (duplicate of 'N?')
digr O~ 213  " Õ (duplicate of 'O?')
digr U~ 360  " Ũ (duplicate of 'U?')
digr V~ 7804 " Ṽ (duplicate of 'V?')
digr Y~ 7928 " Ỹ (duplicate of 'Y?')
digr a~ 227  " ã (duplicate of 'a?')
digr e~ 7869 " ẽ (duplicate of 'e?')
digr i~ 297  " ĩ (duplicate of 'i?')
digr n~ 241  " ñ (duplicate of 'n?')
digr o~ 245  " õ (duplicate of 'o?')
digr u~ 361  " ũ (duplicate of 'u?')
digr v~ 7805 " ṽ (duplicate of 'v?')
digr y~ 7929 " ỹ (duplicate of 'y?')

"" Chinese numerals
digr 0C 12295  " 〇  (duplicate of '0_')
digr 1C 19968  " 一
digr 2C 20108  " 二
digr 3C 19977  " 三
digr 4C 22235  " 四
digr 5C 20116  " 五
digr 6C 20845  " 六
digr 7C 19971  " 七
digr 8C 20843  " 八
digr 9C 20061  " 九
digr tC 21313  " 十
digr sC 30334  " 百
digr bC 21315  " 千
digr wC 33836  " 萬

"" Unicode phonetic symbols
""" https://en.wikipedia.org/wiki/Phonetic_symbols_in_Unicode
digr 44 603   " ɛ
digr cc 596   " ɔ
digr ei 477   " ǝ (overrides ㄟ)
digr ri 633   " ɹ (overrides り)
digr jz 658   " ʒ
" ɜ reversed open e

"" Arrows
""" https://en.wikipedia.org/wiki/Arrows_(Unicode_block)
digr =^ 8657  " ⇑
digr =v 8659  " ⇓
digr -< 8610  " ↢
digr >- 8611  " ↣

" Invisible unicode
digr ZW 8203  " ZWS: https://en.wikipedia.org/wiki/Zero-width_space
digr ZJ 8204  " ZWJ overriding Hebrew letter צ)

" Unicode bidirectional codes
"digr RT 8207  " RIGHT-TO-LEFT MARK
"digr LT 8235  " LEFT-TO-RIGHT MARK
digr LO 8237  " Left-to-right Override
digr RO 8238  " Right-to-left Override (overriding ▢) 
digr LI 8294  " Left-to-right Isolate force
digr RI 8295  " Right-to-left Isolate force 
digr LE 8234  " Left-to-right Embedding
digr RE 8235  " Right-to-left Embedding

digr PI 8297  " Pop Directional Isolate Terminate nearest LRI or RLI (overriding ¶)
digr PF 8236  " Pop Directional Formatting Terminate nearest LRE, RLE, LRO, or RLO

"LRE U+202A Left-to-Right Embedding Try treating following text as left-to-right.
"RLE U+202B Right-to-Left Embedding Try treating following text as right-to-left.
"LRO U+202D Left-to-Right Override Force treating following text as left-to-right.
"RLO U+202E Right-to-Left Override Force treating following text as right-to-left.
"LRI U+2066 Left-to-Right Isolate Force treating following text as left-to-right without affecting adjacent text.
"RLI U+2067 Right-to-Left Isolate Force treating following text as right-to-left without affecting adjacent text.
"
"FSI U+2068 First Strong Isolate Force treating following text in direction indicated by the next character.
"
"PDF U+202C Pop Directional Formatting Terminate nearest LRE, RLE, LRO, or RLO.
"PDI U+2069 Pop Directional Isolate Terminate nearest LRI or RLI.


"" Matrix brackets

"lbrackuend      ⎡
"lbrackextender  ⎢
"lbracklend      ⎣
"rbrackuend      ⎤
"rbrackextender  ⎥
"rbracklend      ⎦
"brace left top ⎧
"brace left middle ⎨
"brace left bottom ⎩
"brace right top ⎫
"brace right middle ⎬
"brace right bottom ⎭
"brace extender     ⎮


"" Box drawing symbols

" ━ (HH)
" ┃ (VV)
" ┏ (DR)
" ┓ (LD)
" ┳ (DH)
" ┻ (UH)
" ┒ (Dl)
" ┑ (dL)
" ┐ (dl)
" ┍ (dR)


" "" Arrows
" """ https://en.wikipedia.org/wiki/Arrow_(symbol)
" " ↖
" " ↘
" " ↗
" " ↙
" " ↾
" " ↿
" " ⇂
" " ⇃
" "
" " Greek question mark: ;
" "
" " ⌊ and ⌋ (floor operation)
" " ⌈ and ⌉ (cieling operation)
" " ∘ (function composition operator) (default digraph: Ob)
" " · (middle dot) (digraph: .M)
" " ∝ (directly proportional) (default digraph: 0()
" "
" " ⨉ U+2A09 N-ARY TIMES OPERATOR
" " ⨯ U+2A2F Cross product
